<template>
  <div class="m-20 flex justify-center">
    <div
      v-if="
        signupProcessState === 'wait for user input' ||
        signupProcessState === 'sign up is refused'
      " 
    >
      <div class="header">
        <p class="my-10">
          {{ $t('signup.form.textBeforeForm') }}
        </p>
      </div>
      <div class="w-full max-w-xl">
        <div class="md:flex md:items-center mb-6">
          <div class="md:w-1/3">
            <label
              class="ada-form-label"
              for="the-page-signup--email"
            >
              {{ $t('signup.form.email') }}
            </label>
          </div>
          <div class="md:w-2/3">
            <input
              v-model="email"
              @keyup.enter="signup"
              class="ada-text-input w-full"
              id="the-page-signup--email"
              type="text"
            >
          </div>
        </div>
        <div class="md:flex md:items-center mb-6">
          <div class="md:w-1/3">
            <label
              class="ada-form-label"
              for="the-page-signup--password"
            >
              {{ $t('signup.form.password') }}
            </label>
          </div>
          <div class="md:w-2/3">
            <PasswordInput
              v-model="password"
              @keyup.enter="signup"
              input-id="the-page-signup--password"
            />
          </div>
        </div>
        <div class="mb-6">
          <div class="md:flex md:items-center mb-1">
            <div class="md:w-1/3">
              <label
                class="ada-form-label ml-2"
                for="the-page-signup--password-check"
              >
                {{ $t('signup.form.passwordCheck') }}
              </label>
            </div>
            <div class="md:w-2/3">
              <PasswordInput
                v-model="passwordCheck"
                @keyup.enter="signup"
                input-id="the-page-signup--password-check"
              />
            </div>
          </div>
          <div
            v-if="!passwordsAreEqual"
            class="md:flex md:items-center mb-2" 
          >
            <div class="md:w-1/3"></div>
            <div class="md:w-2/3 password-error">
              <p>
                {{ $t('signup.messages.passwordError') }}
              </p>
            </div>
          </div>
        </div>

        <div class="md:flex md:items-center mb-1">
          <div class="md:w-1/3">
            <label
              class="ada-form-label"
              for="the-page-signup--display-name"
            >
              {{ $t('signup.form.displayname') }}
            </label>
          </div>
          <div class="md:w-2/3">
            <input
              v-model="displayName"
              @keyup.enter="signup"
              class="ada-text-input w-full"
              id="the-page-signup--display-name"
              type="text"
            >
          </div>
        </div>

        <div
          class="md:flex md:items-center mb-5"
        >
          <div class="md:w-1/3">
          </div>
          <div class="md:w-2/3 bad-display-name">
            <div
              v-if="userHasStartedEditingDisplayName && badDisplayName"
            >
              {{ $t('signup.form.displaynameCondition') }}
            </div>
          </div>
        </div>

        <div
          v-if="allFieldsAreOk"
          class="md:flex md:items-center"
        >
          <div class="md:w-1/3"></div>
          <div class="md:w-2/3">
            <button class="ada-button" type="button" @click="signup">
              {{ $t('signup.actions.signup') }}
            </button>
          </div>
        </div>

      </div>
      <div
        class="my-10 process-state-message"
        v-if="signupProcessState === 'sign up is refused'"
      >
        <p>
          {{ signupError }}
        </p>
      </div>
      <div class="text-after-form">
        <p class="my-10">
          {{ $t('signup.form.textAfterForm') }}
        </p>
        <a class="ada-link" href="/terms">{{ $t('signup.form.linkBeforeForm') }}</a>
      </div>
    </div>
    <div
      v-if="signupProcessState === 'wait for request response'"
      class="process-state-message"
    >
      {{ $t('signup.process.waitForRequest') }}
    </div>
    <div
      v-if="signupProcessState === 'user is signed up'"
      class="process-state-message"
    >
      {{ $t('signup.process.signupSuccessful') }}
    </div>
  </div>
</template>

<script>
import { ref, computed, watch } from 'vue'
import auth from '../auth.js'
import PasswordInput from './PasswordInput.vue'

function emailIsValid(string) {
  const validEmailRegexp = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/
  return validEmailRegexp.test(string)
}

const displayNameIsValid = (displayName) => {
  return displayName.length >= 3 && displayName.length <= 30;
}

export default {
  name: 'ThePageSignUp',
  components: {
    PasswordInput
  },
  setup() {
    const displayName = ref('')
    const email = ref('')
    const password = ref('')
    const passwordCheck = ref('')
    const userHasStartedEditingDisplayName = ref(false)
    watch(displayName, (newValue) => {
      if (userHasStartedEditingDisplayName.value === false && newValue !== '') {
        userHasStartedEditingDisplayName.value = true
      }
    })
    const badDisplayName = computed(() => !displayNameIsValid(displayName.value))
    const passwordsAreEqual = computed(() => (password.value === passwordCheck.value))
    
    const allFieldsAreOk = computed(() => (
      emailIsValid(email.value)
      && password.value !== ''
      && passwordsAreEqual.value
      && displayName.value !== ''
      && displayNameIsValid(displayName.value)
    ))
    return {
      displayName,
      userHasStartedEditingDisplayName,
      badDisplayName,
      email,
      password,
      passwordCheck,
      passwordsAreEqual,
      signupProcessState: ref('wait for user input'),
      signupError: ref(''),
      allFieldsAreOk
    }
  },
  methods: {
    signup () {
      this.signupProcessState = 'wait for request response'
      auth
        .signup(this.email, this.password, { full_name: this.displayName })
        .then((response) => {
          this.signupProcessState = 'user is signed up'
          setTimeout(() => {
            this.$router.push('login')
          }, 2500)
          console.log(response)
        })
        .catch((error) => {
          this.signupProcessState = 'sign up is refused'
          this.signupError = error.message
          console.log(error)
        })
    }
  }
}
</script>

<style lang="postcss" scoped>
.header {
  @apply m-10 max-w-xl;
  @apply text-center text-xl text-gray-700;
  @apply dark:text-gray-300;
}

.bad-display-name {
  @apply text-center text-red-400;
  @apply dark:text-red-600;
}

.text-after-form {
  @apply m-10 max-w-xl;
  @apply text-center text-xl text-gray-700;
  @apply dark:text-gray-300;
}

.password-error {
  @apply text-red-400;
  @apply dark:text-red-600;
}

.process-state-message {
  @apply text-center;
  @apply dark:text-gray-300;
}
</style>